<?php declare(strict_types=1);

namespace Plugin\css_advertGroup\Migrations;

use JTL\Helpers\Text;
use JTL\Plugin\PluginInterface;
use JTL\Shop;
use JTL\Mail\Mail\Mail;
use JTL\Mail\Mailer;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20210429123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20210429123301 extends Migration implements IMigration   {
    /**
     * @inheritdoc
     */

    public function copyTable($sourceDB,$destinationDB="", $copyTable=true,$deleteSourceDB=false) {
        error_log('starte copy '.$sourceDB);
        $result = $this->getDB()->query("SHOW TABLES LIKE '".$sourceDB."'",2);
        if($copyTable && $result !== null && is_array($result) && count($result)) {
            error_log('DB Vorhanden '.$sourceDB);
            $result = $this->getDB()->query("SELECT * FROM ".$sourceDB." WHERE 1",2);
            foreach($result as $oItem) {
                error_log('schreibe Datensatz nach '.$destinationDB);
                $this->getDB()->insert($destinationDB,$oItem);
            }
        }
        if($deleteSourceDB) {
            $this->execute("DROP TABLE IF EXISTS ".$sourceDB,3);
        }
    }


    /*
    define('JTLLOG_LEVEL_EMERGENCY', 600);
    define('JTLLOG_LEVEL_ALERT', 550);
    define('JTLLOG_LEVEL_CRITICAL', 500);
    define('JTLLOG_LEVEL_ERROR', 400);
    define('JTLLOG_LEVEL_WARNING', 300);
    define('JTLLOG_LEVEL_NOTICE', 250);
    define('JTLLOG_LEVEL_INFO', 200);
    define('JTLLOG_LEVEL_DEBUG', 100);
*/

    public function JTLWriteLog($cLog='',$nLevel=JTLLOG_LEVEL_INFO ,$bForce=false) {
            $logger = Shop::Container()->getLogService();
            $logger->log($nLevel, $cLog, ["css_advertGroup"]);
            return true;
    }


    public function up()    {
        $this->execute("
              CREATE TABLE IF NOT EXISTS `css_advertGroupConfig` (
                  `version` varchar(255) NOT NULL DEFAULT '2.0.0',
                  `sqlupdate` int(10) NOT NULL DEFAULT '0',
                  `pluginActive` char(1) NOT NULL default 'N',
                  `framework` char(3) NOT NULL default 'B4',
                  `css` text NOT NULL,
                  `js` text NOT NULL,
                  `selector` varchar(255) NOT NULL DEFAULT '#content',
                  `selector_position` varchar(255) NOT NULL DEFAULT 'prepend',
                  `maxLifeTime` INT(11) NOT NULL DEFAULT '1',
                  `cookieName` VARCHAR(64) NOT NULL DEFAULT 'cssAffiliate'
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");

	    $this->execute("
					CREATE TABLE IF NOT EXISTS `css_advertGroupGroupToKampagne` (
					  `kKampagne` int(10) NOT NULL DEFAULT '0',
					  `kKundengruppe` int(10) NOT NULL DEFAULT '0'
					) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");

	    $this->execute("
					CREATE TABLE IF NOT EXISTS `css_advertGroupUserToKampagne` (
					  `kArtikel` int(10) NOT NULL DEFAULT '0',
					  `kKundengruppe` int(10) NOT NULL DEFAULT '0',
					  `hash` varchar(255) NOT NULL DEFAULT '',
					  `tstamp` int(11) NOT NULL DEFAULT '0'
					) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");

        $this->copyTable("css_advertGroup_konfig","css_advertGroupConfig",true,false);
        $this->copyTable("css_advertGroup_groupToKampagne","css_advertGroupGroupToKampagne",true,false);
        $this->copyTable("css_advertGroup_userToKampagne","css_advertGroupUserToKampagne",true,false);


        $result = $this->getDB()->query(
            'SELECT * from `css_advertGroupConfig` where 1',
            2
        );

        if($result === null || count($result) < 1) {
           $this->execute(
            "INSERT INTO `css_advertGroupConfig` (`version`) VALUES ('2.0.0')"
            );
        } else {
            $this->execute("UPDATE css_advertGroupConfig set `version` = '2.0.0' ");
        }
    }

    /**
     * @inheritdoc
     */
    public function down() {
        if ($this->doDeleteData()) {
            self::JTLWriteLog('drop Tables from css_advertGroup');
        }
    }
}
